/*
Database		mySQL 4.0 
*/


drop table IF EXISTS Permission;
drop table IF EXISTS Invoice_Header;
drop table IF EXISTS Phone;
drop table IF EXISTS Supplier;
drop table IF EXISTS Invoice_Details;
drop table IF EXISTS PhoneModal;
drop table IF EXISTS Stock;
drop table IF EXISTS Customer;
drop table IF EXISTS Purchase_Details;
drop table IF EXISTS Purchase_Header;
drop table IF EXISTS Unit;




Create table Unit (
	Unit_No Int NOT NULL,
	Unit_Description Char(5) NOT NULL,
 Primary Key (Unit_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Purchase_Header (
	Document_No Int NOT NULL,
	Date Datetime,
	Remark Char(50),
	Verify Bool,
	Supplier_No Int NOT NULL,
 Primary Key (Document_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Purchase_Details (
	Document_No Int NOT NULL,
	Phone_No Int NOT NULL,
	PhoneModal_No Int NOT NULL,
	Unit_No Int NOT NULL,
	Quantity Int,
	Rate Float,
	Amount Float,
 Primary Key (Document_No,Phone_No,PhoneModal_No,Unit_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Customer (
	Customer_No Int NOT NULL,
	Customer_Name Char(100) NOT NULL,
	Address Char(50),
	Phone Char(30),
	Fax Char(30),
	E_Mail Char(50),
 Primary Key (Customer_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Stock (
	Document_No Int NOT NULL,
	Phone_No Int NOT NULL,
	PhoneModal_No Int NOT NULL,
	Unit_No Int NOT NULL,
	Quantity Smallint,
	Rate Float,
	Balance Float,
 Primary Key (Document_No,Phone_No,PhoneModal_No,Unit_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table PhoneModal (
	Phone_No Int NOT NULL,
	PhoneModal_No Int NOT NULL,
	PhoneModal_Name Char(50) NOT NULL,
	Unit_No Int NOT NULL,
	ReOrder Smallint,
	Iinterest Float,
	Picture Text,
 Primary Key (Phone_No,PhoneModal_No,Unit_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Invoice_Details (
	Documents_No Int NOT NULL,
	Document_No Int NOT NULL,
	Supplier_No Int NOT NULL,
	Phone_No Int NOT NULL,
	PhoneModal_No Int NOT NULL,
	Unit_No Int NOT NULL,
	Quantity Float,
	Rate Float,
	Amount Float,
	Profit Float,
	Wastage Float,
 Primary Key (Documents_No,Document_No,Supplier_No,Phone_No,PhoneModal_No,Unit_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Supplier (
	Supplier_No Int NOT NULL,
	Supplier_Name Char(50) NOT NULL,
	Address Char(50),
	Phone Char(30),
	Fax Char(30),
	E_Mail Char(50),
	UNIQUE (Supplier_Name),
 Primary Key (Supplier_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Phone (
	Phone_No Int NOT NULL,
	Phone_Name Char(50) NOT NULL,
	UNIQUE (Phone_Name),
 Primary Key (Phone_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Invoice_Header (
	Documents_No Int NOT NULL,
	Date Char(50),
	Person Char(50),
	Customer_No Int,
	Remark Char(50),
	Verify Bool,
	Warranty Smallint,
 Primary Key (Documents_No)) TYPE = MyISAM
ROW_FORMAT = Default;

Create table Permission (
	No Int NOT NULL,
	User_Name Char(30),
	Password Char(50),
	Add Bool,
	Edit Bool,
	Delete Bool,
	Preview Bool,
	Verify Bool,
	User_Control Bool,
	Information Bool,
	Report Bool,
	ReOrder Bool,
	Phone Bool,
	PhoneModal Bool,
	Unit Bool,
	Supplier Bool,
	Customer Bool,
	Sale Bool,
	Purchase Bool,
 Primary Key (No)) TYPE = MyISAM
ROW_FORMAT = Default;












Alter table PhoneModal add Index IX_UnitWithPhoneModal (Unit_No);
Alter table PhoneModal add Foreign Key (Unit_No) references Unit (Unit_No) on delete  restrict on update  restrict;
Alter table Purchase_Details add Index IX_Purchase_One_To_Many (Document_No);
Alter table Purchase_Details add Foreign Key (Document_No) references Purchase_Header (Document_No) on delete  restrict on update  restrict;
Alter table Stock add Index IX_Stock_One_To_Many (Document_No,Phone_No,PhoneModal_No,Unit_No);
Alter table Stock add Foreign Key (Document_No,Phone_No,PhoneModal_No,Unit_No) references Purchase_Details (Document_No,Phone_No,PhoneModal_No,Unit_No) on delete  restrict on update  restrict;
Alter table Invoice_Header add Index IX_Inv_One_To_Many (Customer_No);
Alter table Invoice_Header add Foreign Key (Customer_No) references Customer (Customer_No) on delete  restrict on update  restrict;
Alter table Invoice_Details add Index IX_InvStock (Document_No,Phone_No,PhoneModal_No,Unit_No);
Alter table Invoice_Details add Foreign Key (Document_No,Phone_No,PhoneModal_No,Unit_No) references Stock (Document_No,Phone_No,PhoneModal_No,Unit_No) on delete  restrict on update  restrict;
Alter table Purchase_Details add Index IX_PhoneModalWithPurchase (Phone_No,PhoneModal_No,Unit_No);
Alter table Purchase_Details add Foreign Key (Phone_No,PhoneModal_No,Unit_No) references PhoneModal (Phone_No,PhoneModal_No,Unit_No) on delete  restrict on update  restrict;
Alter table Purchase_Header add Index IX_Supplier_One_To_Many (Supplier_No);
Alter table Purchase_Header add Foreign Key (Supplier_No) references Supplier (Supplier_No) on delete  restrict on update  restrict;
Alter table Invoice_Details add Index IX_InvSupplier (Supplier_No);
Alter table Invoice_Details add Foreign Key (Supplier_No) references Supplier (Supplier_No) on delete  restrict on update  restrict;
Alter table PhoneModal add Index IX_Phone (Phone_No);
Alter table PhoneModal add Foreign Key (Phone_No) references Phone (Phone_No) on delete  restrict on update  restrict;
Alter table Invoice_Details add Index IX_Invoice_One_To_Many (Documents_No);
Alter table Invoice_Details add Foreign Key (Documents_No) references Invoice_Header (Documents_No) on delete  restrict on update  restrict;





