/*
Database		Oracle 8 
*/


Drop table Permission
/
Drop table Invoice_Header
/
Drop table Phone
/
Drop table Supplier
/
Drop table Invoice_Details
/
Drop table PhoneModal
/
Drop table Stock
/
Drop table Customer
/
Drop table Purchase_Details
/
Drop table Purchase_Header
/
Drop table Unit
/














Create table Unit
(
	Unit_No Integer NOT NULL ,
	Unit_Description Char(5) NOT NULL 
)
/

Create table Purchase_Header
(
	Document_No Integer NOT NULL ,
	Date Date,
	Remark Char(50),
	Verify Char(1),
	Supplier_No Integer NOT NULL 
)
/

Create table Purchase_Details
(
	Document_No Integer NOT NULL ,
	Phone_No Integer NOT NULL ,
	PhoneModal_No Integer NOT NULL ,
	Unit_No Integer NOT NULL ,
	Quantity Integer,
	Rate Real,
	Amount Real
)
/

Create table Customer
(
	Customer_No Integer NOT NULL ,
	Customer_Name Char(100) NOT NULL ,
	Address Char(50),
	Phone Char(30),
	Fax Char(30),
	E_Mail Char(50)
)
/

Create table Stock
(
	Document_No Integer NOT NULL ,
	Phone_No Integer NOT NULL ,
	PhoneModal_No Integer NOT NULL ,
	Unit_No Integer NOT NULL ,
	Quantity Smallint,
	Rate Real,
	Balance Real
)
/

Create table PhoneModal
(
	Phone_No Integer NOT NULL ,
	PhoneModal_No Integer NOT NULL ,
	PhoneModal_Name Char(50) NOT NULL ,
	Unit_No Integer NOT NULL ,
	ReOrder Smallint,
	Iinterest Real,
	Picture Long
)
/

Create table Invoice_Details
(
	Documents_No Integer NOT NULL ,
	Document_No Integer NOT NULL ,
	Supplier_No Integer NOT NULL ,
	Phone_No Integer NOT NULL ,
	PhoneModal_No Integer NOT NULL ,
	Unit_No Integer NOT NULL ,
	Quantity Real,
	Rate Real,
	Amount Real,
	Profit Real,
	Wastage Real
)
/

Create table Supplier
(
	Supplier_No Integer NOT NULL ,
	Supplier_Name Char(50) NOT NULL  UNIQUE ,
	Address Char(50),
	Phone Char(30),
	Fax Char(30),
	E_Mail Char(50)
)
/

Create table Phone
(
	Phone_No Integer NOT NULL ,
	Phone_Name Char(50) NOT NULL  UNIQUE 
)
/

Create table Invoice_Header
(
	Documents_No Integer NOT NULL ,
	Date Char(50),
	Person Char(50),
	Customer_No Integer,
	Remark Char(50),
	Verify Char(1),
	Warranty Smallint
)
/

Create table Permission
(
	No Integer NOT NULL ,
	User_Name Char(30),
	Password Char(50),
	Add Char(1),
	Edit Char(1),
	Delete Char(1),
	Preview Char(1),
	Verify Char(1),
	User_Control Char(1),
	Information Char(1),
	Report Char(1),
	ReOrder Char(1),
	Phone Char(1),
	PhoneModal Char(1),
	Unit Char(1),
	Supplier Char(1),
	Customer Char(1),
	Sale Char(1),
	Purchase Char(1)
)
/






Alter table Unit add primary key (Unit_No) 
/
Alter table Purchase_Header add primary key (Document_No) 
/
Alter table Purchase_Details add primary key (Document_No,Phone_No,PhoneModal_No,Unit_No) 
/
Alter table Customer add primary key (Customer_No) 
/
Alter table Stock add primary key (Document_No,Phone_No,PhoneModal_No,Unit_No) 
/
Alter table PhoneModal add primary key (Phone_No,PhoneModal_No,Unit_No) 
/
Alter table Invoice_Details add primary key (Documents_No,Document_No,Supplier_No,Phone_No,PhoneModal_No,Unit_No) 
/
Alter table Supplier add primary key (Supplier_No) 
/
Alter table Phone add primary key (Phone_No) 
/
Alter table Invoice_Header add primary key (Documents_No) 
/
Alter table Permission add primary key (No) 
/



















Alter table PhoneModal add  foreign key (Unit_No) references Unit (Unit_No) 
/
Alter table Purchase_Details add  foreign key (Document_No) references Purchase_Header (Document_No) 
/
Alter table Stock add  foreign key (Document_No,Phone_No,PhoneModal_No,Unit_No) references Purchase_Details (Document_No,Phone_No,PhoneModal_No,Unit_No) 
/
Alter table Invoice_Header add  foreign key (Customer_No) references Customer (Customer_No) 
/
Alter table Invoice_Details add  foreign key (Document_No,Phone_No,PhoneModal_No,Unit_No) references Stock (Document_No,Phone_No,PhoneModal_No,Unit_No) 
/
Alter table Purchase_Details add  foreign key (Phone_No,PhoneModal_No,Unit_No) references PhoneModal (Phone_No,PhoneModal_No,Unit_No) 
/
Alter table Purchase_Header add  foreign key (Supplier_No) references Supplier (Supplier_No) 
/
Alter table Invoice_Details add  foreign key (Supplier_No) references Supplier (Supplier_No) 
/
Alter table PhoneModal add  foreign key (Phone_No) references Phone (Phone_No) 
/
Alter table Invoice_Details add  foreign key (Documents_No) references Invoice_Header (Documents_No) 
/



