/*
Database		MS SQL 2000 
*/


Drop table [Permission] 
go
Drop table [Invoice_Header] 
go
Drop table [Phone] 
go
Drop table [Supplier] 
go
Drop table [Invoice_Details] 
go
Drop table [PhoneModal] 
go
Drop table [Stock] 
go
Drop table [Customer] 
go
Drop table [Purchase_Details] 
go
Drop table [Purchase_Header] 
go
Drop table [Unit] 
go
















Create table [Unit]
(
	[Unit_No] Integer NOT NULL,
	[Unit_Description] Char(5) NOT NULL,
Primary Key ([Unit_No])
) 
go

Create table [Purchase_Header]
(
	[Document_No] Integer NOT NULL,
	[Date] Datetime NULL,
	[Remark] Char(50) NULL,
	[Verify] Bit NULL,
	[Supplier_No] Integer NOT NULL,
Primary Key ([Document_No])
) 
go

Create table [Purchase_Details]
(
	[Document_No] Integer NOT NULL,
	[Phone_No] Integer NOT NULL,
	[PhoneModal_No] Integer NOT NULL,
	[Unit_No] Integer NOT NULL,
	[Quantity] Integer NULL,
	[Rate] Money NULL,
	[Amount] Money NULL,
Primary Key ([Document_No],[Phone_No],[PhoneModal_No],[Unit_No])
) 
go

Create table [Customer]
(
	[Customer_No] Integer NOT NULL,
	[Customer_Name] Char(100) NOT NULL,
	[Address] Char(50) NULL,
	[Phone] Char(30) NULL,
	[Fax] Char(30) NULL,
	[E-Mail] Char(50) NULL,
Primary Key ([Customer_No])
) 
go

Create table [Stock]
(
	[Document_No] Integer NOT NULL,
	[Phone_No] Integer NOT NULL,
	[PhoneModal_No] Integer NOT NULL,
	[Unit_No] Integer NOT NULL,
	[Quantity] Smallint NULL,
	[Rate] Money NULL,
	[Balance] Float NULL,
Primary Key ([Document_No],[Phone_No],[PhoneModal_No],[Unit_No])
) 
go

Create table [PhoneModal]
(
	[Phone_No] Integer NOT NULL,
	[PhoneModal_No] Integer NOT NULL,
	[PhoneModal_Name] Char(50) NOT NULL,
	[Unit_No] Integer NOT NULL,
	[ReOrder] Smallint NULL,
	[Iinterest] Float NULL,
	[Picture] Text NULL,
Primary Key ([Phone_No],[PhoneModal_No],[Unit_No])
) 
go

Create table [Invoice_Details]
(
	[Documents_No] Integer NOT NULL,
	[Document_No] Integer NOT NULL,
	[Supplier_No] Integer NOT NULL,
	[Phone_No] Integer NOT NULL,
	[PhoneModal_No] Integer NOT NULL,
	[Unit_No] Integer NOT NULL,
	[Quantity] Float NULL,
	[Rate] Money NULL,
	[Amount] Money NULL,
	[Profit] Money NULL,
	[Wastage] Money NULL,
Primary Key ([Documents_No],[Document_No],[Supplier_No],[Phone_No],[PhoneModal_No],[Unit_No])
) 
go

Create table [Supplier]
(
	[Supplier_No] Integer NOT NULL,
	[Supplier_Name] Char(50) NOT NULL, UNIQUE ([Supplier_Name]),
	[Address] Char(50) NULL,
	[Phone] Char(30) NULL,
	[Fax] Char(30) NULL,
	[E-Mail] Char(50) NULL,
Primary Key ([Supplier_No])
) 
go

Create table [Phone]
(
	[Phone_No] Integer NOT NULL,
	[Phone_Name] Char(50) NOT NULL, UNIQUE ([Phone_Name]),
Primary Key ([Phone_No])
) 
go

Create table [Invoice_Header]
(
	[Documents_No] Integer NOT NULL,
	[Date] Char(50) NULL,
	[Person] Char(50) NULL,
	[Customer_No] Integer NULL,
	[Remark] Char(50) NULL,
	[Verify] Bit NULL,
	[Warranty] Smallint NULL,
Primary Key ([Documents_No])
) 
go

Create table [Permission]
(
	[No] Integer NOT NULL,
	[User_Name] Char(30) NULL,
	[Password] Char(50) NULL,
	[Add] Bit NULL,
	[Edit] Bit NULL,
	[Delete] Bit NULL,
	[Preview] Bit NULL,
	[Verify] Bit NULL,
	[User_Control] Bit NULL,
	[Information] Bit NULL,
	[Report] Bit NULL,
	[ReOrder] Bit NULL,
	[Phone] Bit NULL,
	[PhoneModal] Bit NULL,
	[Unit] Bit NULL,
	[Supplier] Bit NULL,
	[Customer] Bit NULL,
	[Sale] Bit NULL,
	[Purchase] Bit NULL,
Primary Key ([No])
) 
go






















Alter table [PhoneModal] add  foreign key([Unit_No]) references [Unit] ([Unit_No])  on update no action on delete no action 
go
Alter table [Purchase_Details] add  foreign key([Document_No]) references [Purchase_Header] ([Document_No])  on update no action on delete no action 
go
Alter table [Stock] add  foreign key([Document_No],[Phone_No],[PhoneModal_No],[Unit_No]) references [Purchase_Details] ([Document_No],[Phone_No],[PhoneModal_No],[Unit_No])  on update no action on delete no action 
go
Alter table [Invoice_Header] add  foreign key([Customer_No]) references [Customer] ([Customer_No])  on update no action on delete no action 
go
Alter table [Invoice_Details] add  foreign key([Document_No],[Phone_No],[PhoneModal_No],[Unit_No]) references [Stock] ([Document_No],[Phone_No],[PhoneModal_No],[Unit_No])  on update no action on delete no action 
go
Alter table [Purchase_Details] add  foreign key([Phone_No],[PhoneModal_No],[Unit_No]) references [PhoneModal] ([Phone_No],[PhoneModal_No],[Unit_No])  on update no action on delete no action 
go
Alter table [Purchase_Header] add  foreign key([Supplier_No]) references [Supplier] ([Supplier_No])  on update no action on delete no action 
go
Alter table [Invoice_Details] add  foreign key([Supplier_No]) references [Supplier] ([Supplier_No])  on update no action on delete no action 
go
Alter table [PhoneModal] add  foreign key([Phone_No]) references [Phone] ([Phone_No])  on update no action on delete no action 
go
Alter table [Invoice_Details] add  foreign key([Documents_No]) references [Invoice_Header] ([Documents_No])  on update no action on delete no action 
go


Set quoted_identifier on
go




















Set quoted_identifier off
go
