Attribute VB_Name = "Album"
Option Explicit
' Capture Screen
Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, lpInitData As String) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Declare Function EmptyClipboard Lib "user32" () As Long
Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Declare Function CloseClipBoard Lib "user32" Alias "CloseClipboard" () As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long



Enum BrowseForFolderFlags
    BIF_RETURNONLYFSDIRS = &H1
    BIF_DONTGOBELOWDOMAIN = &H2
    BIF_STATUSTEXT = &H4
    BIF_BROWSEFORCOMPUTER = &H1000
    BIF_BROWSEFORPRINTER = &H2000
    BIF_BROWSEINCLUDEFILES = &H4000
    BIF_EDITBOX = &H10
    BIF_RETURNFSANCESTORS = &H8
End Enum

Private Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lparam As Long
    iImage As Long
End Type


Public db As Database
Public RS As Recordset
Public Path1 As String
Public LenDb As Long
Public PicName As String
Public Pic As String
Public Slide As Boolean
Public NameOf As String
Public InfoOf As String
Public TemDir As String
Public TempTime As Double
Public exitPause As Boolean
Public OutOfIt As Boolean
Public MakeNew As Boolean
Public ScanImage As Boolean
Public PicPathName As String
Public ChangeName As Boolean
Public PixDir As String
Public nodX As Node
Public AddCat As Boolean
Public CatName As String
Public NewFromMain As Boolean
Public NewFromAdd As Boolean
Public blnScan As Boolean
Public blnCapture As Boolean
Public dbFileName As String
Public strMidiName As String
Public MIDIFound As Boolean
Public strToImgN1 As String


Public Function LoadList1()

    Dim i As Integer
    Dim iAdd As Long

    On Error Resume Next

    FrmMain.List1.Clear

    On Error Resume Next
    RS.MoveFirst
    If RS.EOF Then Exit Function
    For i = 1 To RS.RecordCount
        FrmMain.List1.AddItem RS.Fields(0)
        RS.MoveNext
    Next i

    For iAdd = 1 To FrmMain.TV1.Nodes.Count
        If FrmMain.TV1.Nodes.item(iAdd).Text = CatName Then
            FrmMain.TV1.SetFocus
            FrmMain.TV1.Nodes(iAdd).Selected = True
            FrmMain.bg(2).Caption = CatName & " - [ " & FrmMain.List1.ListCount & " ]"
            Exit For
        End If
    Next iAdd

End Function

Public Function BrowseForFolder(hwnd As Long, Optional Title As String, Optional Flags As BrowseForFolderFlags) As String

    Dim iNull As Integer
    Dim IDList As Long
    Dim result As Long
    Dim Path As String
    Dim bi As BrowseInfo
    Dim hwndOwner As Long

    If Flags = 0 Then Flags = BIF_RETURNONLYFSDIRS

    With bi
        .hwndOwner = hwndOwner
        .lpszTitle = lstrcat(Title, "")
        .ulFlags = Flags
    End With

    IDList = SHBrowseForFolder(bi)

    If IDList Then
        Path = String$(300, 0)
        result = SHGetPathFromIDList(IDList, Path)
        iNull = InStr(Path, vbNullChar)
        If iNull Then Path = left$(Path, iNull - 1)
    End If

    BrowseForFolder = Path
End Function

Public Function OpenDb()

    Call GetTables(dbFileName)

    If NewFromAdd = True Then
        CatName = FrmAdd.cboCat.Text
    End If

    If NewFromMain = True Then
        CatName = FrmMain.TV1.Nodes.item(2)
    End If

    Set db = OpenDatabase(dbFileName)
    Set RS = db.OpenRecordset(CatName)


End Function

Public Function CloseDb()

    On Error Resume Next
    RS.Close: Set RS = Nothing: db.Close: Set db = Nothing

End Function


Public Function CreateDb()

    If MakeNew = True Then GoTo YES_Create

    Dim msg, Style, Title, Response

    msg = "WARNNING !!! This will Overwrite Your Database you are Now Using" & vbCrLf & _
            "YOU NEED TO BACKUP THE DATABASE BEFORE MAKING A NEW ON" & vbCrLf & _
            "Do You Want to Continue ?"

    Response = MsgBox(msg, vbYesNo + vbInformation + vbDefaultButton2, "Create New DataBase")
    If Response = vbNo Then Exit Function

YES_Create:

    CloseDb

    Dim NewDB As Database
    Dim NewTable As TableDef

    If Dir(dbFileName) <> "" Then
        Close
        Kill dbFileName
    End If


    Set NewDB = CreateDatabase(dbFileName, dbLangGeneral)
    Set NewTable = NewDB.CreateTableDef("General")


    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Pic", dbLongBinary)
    End With

    NewDB.TableDefs.Append NewTable

    Set NewTable = NewDB.CreateTableDef("Collections")

    With NewTable
        .Fields.Append .CreateField("Name", dbText)
    End With

    NewDB.TableDefs.Append NewTable

    On Error Resume Next

    NewDB.Close

    Set db = OpenDatabase(dbFileName)
    Set RS = db.OpenRecordset("Collections")

    With RS
        .AddNew
        .Fields(0) = "General"
        .Update
    End With

    On Error Resume Next

    NewDB.Close

    If MakeNew = True Then GoTo YES_New_Database
    MsgBox "A New Photo DataBase has been Created", , "Create DataBase"

YES_New_Database:

    MakeNew = False

    RS.Close
    db.Close
    OpenDb
    LoadList1

End Function


Public Function SaveResItemToDisk(ByVal iResourceNum As Integer, ByVal sResourceType As String, ByVal sDestFileName As String) As Long


    Dim bytResourceData()   As Byte
    Dim iFileNumOut         As Integer

    On Error GoTo SaveResItemToDisk_err

    bytResourceData = LoadResData(iResourceNum, sResourceType)

    iFileNumOut = FreeFile

    Open sDestFileName For Binary Access Write As #iFileNumOut

    Put #iFileNumOut, , bytResourceData

    Close #iFileNumOut

    SaveResItemToDisk = 0

    Exit Function

SaveResItemToDisk_err:
    SaveResItemToDisk = Err.Number

End Function

Private Sub SaveIt()

    OpenDb

    RS.AddNew

    Dim iRetVal As Long
    iRetVal = SaveResItemToDisk(101, "PIC", TemDir & "\USMC.jpg")

    RS.Fields(0) = "USMC.jpg"

    '*************Start of Copy File (image) To DataBase**********************************

    Dim Img() As Byte, i As Long

    Close #1

    Open TemDir & "\USMC.jpg" For Binary As 1
    ReDim Img(LOF(1))
    'get the File and put it in the Virable
    Do While Not EOF(1)
        Get #1, , Img
        i = i + 1
    Loop
    Close #1

    RS.Fields(1) = Img
    Kill TemDir & "\USMC.jpg"

    Dim ms As String
    ms = "USMC.jpg is a Picture I had laying around" & vbCrLf
    ms = ms & "and just put it here to have something" & vbCrLf
    ms = ms & "to add to the DataBase. You can Delete this Item"

    RS.Fields(2) = ms
    RS.Update

End Sub

Public Sub NewCategory()

    'Open the RecordSet
    Set RS = db.OpenRecordset("Collections")

    With RS
        .AddNew
        .Fields(0) = CatName
        .Update
    End With

    CloseDb

    FrmMain.TV1.Nodes.Clear
    FrmMain.List1.Clear

    CreatNewCat


    OpenDb


    LoadList1

    FrmMain.Image2.Picture = LoadPicture()
    FrmMain.Image1.Visible = True

End Sub

Public Function GetTables(dbPath As String) As Collection


    On Error GoTo ErrHandler

    Dim td As DAO.TableDef
    Dim db As DAO.Database
    Dim colTables As Collection
    Dim LastNode

    FrmMain.TV1.Nodes.Clear

    Set db = Workspaces(0).OpenDatabase(dbPath)

    Set colTables = New Collection

    Set nodX = FrmMain.TV1.Nodes.Add(, , "R", "My Pictures", 1)


    For Each td In db.TableDefs

        If td.Attributes >= 0 And td.Attributes <> dbHiddenObject _
                And td.Attributes <> 2 Then
            If td.Name <> "Collections" Then

                colTables.Add td.Name

                CatName = td.Name

                Set RS = db.OpenRecordset(td.Name)

                Set nodX = FrmMain.TV1.Nodes.Add("R", tvwChild, RS.Name, RS.Name, 2)

            End If
        End If
    Next

    nodX.EnsureVisible

    db.Close
    Set GetTables = colTables

    Exit Function

ErrHandler:
    On Error Resume Next
    If Not db Is Nothing Then db.Close
    Set GetTables = Nothing

End Function



Public Sub CreatNewCat()

    Dim TempTable As TableDef
    Set db = OpenDatabase(dbFileName)

    'Create a New Table
    Set TempTable = db.CreateTableDef(CatName)

    'Put the Fields in the New Table
    With TempTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Pic", dbLongBinary)
    End With

    db.TableDefs.Append TempTable

    CloseDb

End Sub
