Attribute VB_Name = "mdlRtb"
Option Explicit
Private Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type CharRange
    cpMin As Long     'First character of range (0 for start of doc)
    cpMax As Long     'Last character of range (-1 for end of doc)
End Type
Private Type FormatRange
    hdc As Long       'Actual DC to draw on
    hdcTarget As Long 'Target DC for determining text formatting
    rc As Rect        'Region of the DC to draw to (in twips)
    rcPage As Rect    'Region of the entire DC (page size) (in twips)
    chrg As CharRange 'Range of text to draw (see above declaration)
End Type
Private Type POINTAPI
    x As Long
    y As Long
End Type
Private Const WM_USER As Long = &H400
Private Const EM_FORMATRANGE As Long = WM_USER + 57
Private Const EM_SETTARGETDEVICE As Long = WM_USER + 72
Private Const PHYSICALOFFSETX As Long = 112
Private Const PHYSICALOFFSETY As Long = 113
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As Long, ByVal lpInitData As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const EM_SETMARGINS = &HD3
Private Const EC_LEFTMARGIN = &H1
Private Const EC_RIGHTMARGIN = &H2
Private Const EM_CHARFROMPOS = &HD7
Private Const EM_LINESCROLL As Long = &HB6
Public PrevPage As String
Public CurrPage As String
Public PageRect As Rect
Public Sub LoadPage(Page As Node, RtbMed As RichTextBox, ByVal Pos As Long)
    On Error GoTo ErrHndlr
    RtbMed.TextRTF = ""
    PrevPage = CurrPage
    CurrPage = Page.Key
    If Signature = "WRK FILE" Then
        Dim NumFile As Integer
        Dim FilePos As Long
        Dim Length As Long
        Dim Buffer As String
        NumFile = FreeFile
        Open BckFile For Binary As #NumFile
        FilePos = CLng(Val(Page.Tag))
        Get #NumFile, FilePos, Length
        FilePos = FilePos + 4
        Buffer = String(Length, 0)
        Get #NumFile, FilePos, Buffer
        Close #NumFile
        RtbMed.TextRTF = Buffer
    Else
        Dim Ret As String
        Ret = Dir(Page.Tag)
        If Ret <> "" Then
            RtbMed.LoadFile Page.Tag
        Else
            MsgBox "   " & vbCrLf & "       ", vbMsgBoxRight Or vbMsgBoxRtlReading, " "
        End If
    End If
    RtbMed.Refresh
    Dim NumLine As Long
    Dim Result As Long
    NumLine = RtbMed.GetLineFromChar(Pos)
    Result = SendMessage(RtbMed.hwnd, EM_LINESCROLL, 0, ByVal NumLine)
    Exit Sub
ErrHndlr:
    MsgBox Err.Number & vbCrLf & Err.Description, vbMsgBoxRight Or vbMsgBoxRtlReading, " "
End Sub
Public Function GetCharPos(RtbMed As RichTextBox, ByVal Px As Single, ByVal Py As Single) As Long
    Dim Pos As POINTAPI
    Pos.x = Px / Screen.TwipsPerPixelX
    Pos.y = Py / Screen.TwipsPerPixelY
    GetCharPos = SendMessage(RtbMed.hwnd, EM_CHARFROMPOS, 0, Pos)
End Function
Public Sub SetMargins(ByVal Hwd As Long, ByVal LeftMargin As Integer, ByVal RightMargin As Integer)
    Dim LongValue As Long
    LongValue = LeftMargin * &H10000 + RightMargin
    SendMessage Hwd, EM_SETMARGINS, EC_LEFTMARGIN Or EC_RIGHTMARGIN, ByVal LongValue
End Sub
Public Sub PrintRTF(RTF As RichTextBox, LeftMarginWidth As Long, TopMarginHeight, RightMarginWidth, BottomMarginHeight)
    Dim LeftOffset As Long, TopOffset As Long
    Dim LeftMargin As Long, TopMargin As Long
    Dim RightMargin As Long, BottomMargin As Long
    Dim fr As FormatRange
    Dim rcDrawTo As Rect
    Dim rcPage As Rect
    Dim TextLength As Long
    Dim NextCharPosition As Long
    Dim r As Long
    'Start a print job to get a valid Printer.hDC
    Printer.Print Space(1)
    Printer.ScaleMode = vbTwips
    'Get the offsett to the printable area on the page in twips
    LeftOffset = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
    PHYSICALOFFSETX), vbPixels, vbTwips)
    TopOffset = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
    PHYSICALOFFSETY), vbPixels, vbTwips)
    'Calculate the Left, Top, Right, and Bottom margins
    LeftMargin = LeftMarginWidth - LeftOffset
    TopMargin = TopMarginHeight - TopOffset
    RightMargin = (Printer.Width - RightMarginWidth) - LeftOffset
    BottomMargin = (Printer.Height - BottomMarginHeight) - TopOffset
    'Set printable area rect
    rcPage.Left = 0
    rcPage.Top = 0
    rcPage.Right = Printer.ScaleWidth
    rcPage.Bottom = Printer.ScaleHeight
    'Set rect in which to print (relative to printable area)
    rcDrawTo.Left = LeftMargin
    rcDrawTo.Top = TopMargin
    rcDrawTo.Right = RightMargin
    rcDrawTo.Bottom = BottomMargin
    'Set up the print instructions
    fr.hdc = Printer.hdc   'Use the same DC for measuring and rendering
    fr.hdcTarget = Printer.hdc  'Point at printer hDC
    fr.rc = rcDrawTo            'Indicate the area on page to draw to
    fr.rcPage = rcPage          'Indicate entire size of page
    fr.chrg.cpMin = 0           'Indicate start of text through
    fr.chrg.cpMax = -1          'end of the text
    'Get length of text in RTF
    TextLength = Len(RTF.Text)
    'Loop printing each page until done
    Do
        'Print the page by sending EM_FORMATRANGE message
        NextCharPosition = SendMessage(RTF.hwnd, EM_FORMATRANGE, True, fr)
        If NextCharPosition >= TextLength Then Exit Do  'If done then exit
        fr.chrg.cpMin = NextCharPosition 'Starting position for next page
        Printer.NewPage                  'Move on to next page
        Printer.Print Space(1) 'Re-initialize hDC
        fr.hdc = Printer.hdc
        fr.hdcTarget = Printer.hdc
    Loop
    'Commit the print job
    Printer.EndDoc
    'Allow the RTF to free up memory
    r = SendMessage(RTF.hwnd, EM_FORMATRANGE, False, ByVal CLng(0))
End Sub

